<?php
namespace app\index\controller;
use think\Controller;
use think\Db;
class Index extends Controller
{
	
    public function index()
    {
        
		
		$list = Db::name('links')->order('id asc')->paginate(10000);
		
		//采集内容开始链接
		$listStar = Db::name('links')->where('status',0)->order('id asc')->value('url'); 
		
		//提取内容开始id
		$getStarId = Db::name('links')->where('status',1)->order('id asc')->value('id');
		
		return $this->fetch('',['list'=>$list,'listStar'=>$listStar,'getStarId'=>$getStarId]);
	
	}
	
	

	//采集分类链接
	public function getList(){
		
		$data = input('post.');
		$list = $data['list'];
		$cateName = $data['cateName'];
		$status = 0;
		
		$inserData = array();
		
		$count = 0;
		$re = 0;
		foreach($list as $k=>$v){
			$inserData['url'] = $v;
			$inserData['cateName'] = $cateName;
			$inserData['status'] = $status;
			
			$check = Db::name('links')->where(['url'=>$v,'cateName'=>$cateName])->count();
			if($check == 0){
				 Db::name('links')->insert($inserData);
			}else{
				$re++;
			}
			$count++;
		}
		return '成功采集链接'.$count.'条，重复'.$re.'条';
	}
	
	//获取祥情
	public function getContent(){
		
		$html = input('html');
		$url = input('url');
		$id = Db::name('links')->where('url',$url)->value('id');
		
		file_put_contents('./cjhtml/'.$id.'.html',$html);
		Db::name('links')->where('id',$id)->update(['status'=>1]); //修改状态
		
		
		$maxId = Db::name('links')->max('id');
		if($id == $maxId){
			return json(['url'=>'采集完成！','sta'=>1]);
		}

		$next = Db::name('links')->where('id','>',$id)->where('status',0)->order('id asc')->limit(1)->find();
		
		$sle = mt_rand(2000,5000);
		return json(['url'=>$next['url'],'sta'=>0,'sle'=>$sle]);
	}
	
	
	
	//提取数据
	public function getAllData(){
		$list = Db::name('links')->where('status',1)->order('id asc')->select();
		foreach($list as $k=>$v){
			$res = $this->getData($v['id']);
			echo $res.'<br/>';
		}
		echo '采集完成！';
	}
	
	public function getData($id){
		
		if(!file_exists('./cjhtml/'.$id.'.html')){
			return $id.'-文件不存在';
		}
		$html = file_get_contents('./cjhtml/'.$id.'.html');
		
		//标题
		$title = preg_match('/<title>([\s\S]+)<\/title>/U',$html,$ti);
		$title = $ti[1];
		//dump($id);
		
		//主图
		preg_match('/<div\sclass=\"img-list-wrapper\"[\s\S]+>[\s\S]+detail-gallery-right-button/U',$html,$i);
		
		$imgsCode = $i[0];
		preg_match_all('/src=\"([\s\S]+)\"/U',$imgsCode,$i2);
		$imgs= $i2[1];
		foreach($imgs as $k=>$v){
			$imgs[$k] = str_replace('./','/',$this->grabImage($v,'./uploads/cj/img'));
		}
		//debug($imgs);
		
		//祥情
		$content = preg_match('/<div\sclass=\"content-detail\">([\s\S]+)class=\"detail-custom-data\"/U',$html,$ci);
		$content = substr($ci[1],0,-23);
		$content = $this->loadContent($content);
		
		//debug($content);
		$res = Db::name('links')->where('id',$id)->update([
			'title'=>$title,
			'imgs'=>json_encode($imgs),
			'content'=>$content,
			'status'=>2
		]);
		
	
		return $id;
	}
	
	
	public function getOneData(){
		
		$id = input('id');
		
		if(!file_exists('./cjhtml/'.$id.'.html')){
			return json(['sta'=>0,'msg'=>'文件不存在']);
		}
		$html = file_get_contents('./cjhtml/'.$id.'.html');
		
		//标题
		$title = preg_match('/<title>([\s\S]+)<\/title>/U',$html,$ti);
		$title = $ti[1];
		//dump($id);
		
		//主图
		preg_match('/<div\sclass=\"img-list-wrapper\"[\s\S]+>[\s\S]+detail-gallery-right-button/U',$html,$i);
		
		$imgsCode = $i[0];
		preg_match_all('/src=\"([\s\S]+)\"/U',$imgsCode,$i2);
		$imgs= $i2[1];
		foreach($imgs as $k=>$v){
			$imgs[$k] = str_replace('./','/',$this->grabImage($v,'./uploads/cj/img'));
		}
		//debug($imgs);
		
		//祥情
		$content = preg_match('/<div\sclass=\"content-detail\">([\s\S]+)class=\"detail-custom-data\"/U',$html,$ci);
		$content = substr($ci[1],0,-23);
		$content = $this->loadContent($content);
		
		//debug($content);
		$res = Db::name('links')->where('id',$id)->update([
			'title'=>$title,
			'imgs'=>json_encode($imgs),
			'content'=>$content,
			'status'=>2
		]);
		
		$next = Db::name('links')->where('status',1)->order('id asc')->find();
		
		if($next){
			return json(['sta'=>1,'msg'=>'','nextId'=>$next['id']]);
		}else{
			return json(['sta'=>3,'msg'=>'提取完成了']);
		}
		
		
	}
	
	
	
	//祥情图片本地化
	public function loadContent($content){
		
		$img = preg_match_all('/<img[\s\S]+data-lazyload-src=\"([\s\S]+)\"[\s\S]+>/U',$content,$i);
		$imgTag = $i[0];
		$imgs = $i[1];
		
		foreach($imgs as $k=>$v){
			$imgs[$k] = str_replace('./','/',$this->grabImage($v,'./uploads/cj/content'));
		}
		
		foreach($imgs as $k=>$v){
			$content = str_replace($imgTag[$k],'<img src="'.$v.'">',$content);
		}
		return $content;
	}
	
	

	//$a_url远程图片地址
	//$a_savePath 本地存储地址
	public function grabImage($a_url,$a_savePath){
		$a_url=str_replace(['&'],['&'],$a_url);
		$imgSize=getImageSize($a_url);
		if(!in_array($imgSize['mime'],array('image/jpg','image/gif','image/png','image/jpeg'),true)){return '';}
			$_mime = explode('/', $imgSize['mime']);
			$ext = '.'.end($_mime);
			if($ext == '.jpeg'){$ext = '.jpg';}
			$new_file = $a_savePath ."/";
			if (!file_exists($new_file)) {
				//检查是否有该文件夹，如果没有就创建，并给予最高权限
				mkdir($new_file, 0700);
			}
			$filename_r = md5($a_url).$ext;	//给图片命名
			$filename = $new_file.$filename_r;//.'/'
			
			if(file_exists($filename)){ //存在则直接返回
				return $filename;
			}
			
			ob_start();	//打开缓冲区
			readfile($a_url);	
			$imgInfo = ob_get_contents();	//获得缓冲区的内容
			ob_end_clean(); //清除并关闭缓冲区
			//$fp = fopen($filename,'a');		fwrite($fp,$imgInfo);	fclose($fp);
		
			$fp = fopen($filename, 'a');
			$imgLen = strlen($imgInfo);    //计算图片源码大小
			$_inx = 1024;   //每次写入1k
			$_time = ceil($imgLen/$_inx);
			for($i=0; $i<$_time; $i++){
				fwrite($fp,substr($imgInfo, $i*$_inx, $_inx));
			}
			fclose($fp);	unset($imgInfo,$a_url);
			return $filename;
		
    }
	
	//手动写入数据
	public function pushData()
	{
		die();
		$db2 = [
			// 数据库类型
			'type'        => 'mysql',
			// 数据库连接DSN配置
			'dsn'         => '',
			// 服务器地址
			'hostname'    => '120.25.75.131',
			// 数据库名
			'database'    => '1008',
			// 数据库用户名
			'username'    => '1008',
			// 数据库密码
			'password'    => 'HKTJAK2ishydFxe5',
			// 数据库连接端口
			'hostport'    => '',
			// 数据库连接参数
			'params'      => [],
			// 数据库编码默认采用utf8
			'charset'     => 'utf8',
			// 数据库表前缀
			'prefix'      => 'bp_',
		];
		
		//93">产品展示</option>
		//132">|--------长排较</option>
		//131">|--------脚杯</option>
		//130">|--------拉手</option>
		//129">|--------合页饺链</option>
		//143	搭扣
		
		$cateName = '搭扣类';
		
		
		$data = Db::name('links')->where('cateName',$cateName)->field('title,imgs,content')->select();
		$insertData = array();
		foreach($data as $k=>$v){
			$v['cover'] = json_decode($v['imgs'],true)[0];
			$v['addtime'] = time();
			$v['edittime'] = time();
			$v['catid'] = 143;
			$v['lang'] = 'def';
			$insertData[$k] = $v;
		}
		
		foreach($insertData as $k=>$v){
			$content = $v['content'];
			unset($v['content']);
			$dataId = Db::connect($db2)->table('bp_product')->insertGetId($v);
			Db::connect($db2)->table('bp_product_data')->insert(['dataId'=>$dataId,'content'=>$content]);
		}
		
									
		echo $cateName.'写入成功';
		
	}
	
	
	
    
}
